
/*  A Bison parser, made from parser.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	258
#define	SFBOOL	259
#define	SFCOLOR	260
#define	SFFLOAT	261
#define	SFIMAGE	262
#define	SFINT32	263
#define	SFNODE	264
#define	SFROTATION	265
#define	SFSTRING	266
#define	SFTIME	267
#define	SFVEC2F	268
#define	SFVEC3F	269
#define	MFCOLOR	270
#define	MFFLOAT	271
#define	MFINT32	272
#define	MFROTATION	273
#define	MFSTRING	274
#define	MFVEC2F	275
#define	MFVEC3F	276
#define	MFNODE	277
#define	CLASS	278
#define	EXTERNCLASS	279
#define	EXTENDS	280
#define	DEF	281
#define	USE	282
#define	PROTO	283
#define	EXTERNPROTO	284
#define	TO	285
#define	IS	286
#define	ROUTE	287
#define	SFN_NULL	288
#define	EVENTIN	289
#define	EVENTOUT	290
#define	FIELD	291
#define	EXPOSEDFIELD	292
#define	UNROUTE	293



// only to debug type checking #define TCHECKDEBUG  1

#define myfree(x) free(x) 

int yydebug=1;

//
// Parser for VRML 2.0 files.
// This is a minimal parser that does NOT generate an in-memory scene graph.
// 

// The original parser was developed on a Windows 95 PC with
// Borland's C++ 5.0 development tools.  This was then ported
// to a Windows 95 PC with Microsoft's MSDEV C++ 4.0 development
// tools.  The port introduced the ifdef's for
//    USING_BORLAND_CPP_5          : since this provides a "std namespace",
//    TWO_ARGUMENTS_FOR_STL_STACK  : STL is a moving target.  The stack template
//                                     class takes either one or two arguments.

#include <iostream.h>
#include <stdio.h>
#include <malloc.h>
#include <assert.h>
#include <list.h>
#include <stack.h>
#include <string.h>

#include "vrmlnode.h"

#ifdef USE_STD_NAMESPACE
using namespace std;
#endif

// Currently-being-define proto.  Prototypes may be nested, so a stack
// is needed:

#ifdef TWO_ARGUMENTS_FOR_STL_STACK  
stack< VrmlNodeType*, list<VrmlNodeType*> > currentProtoStack;
#else
stack< list<VrmlNodeType*> > currentProtoStack;
#endif  /* TWO_ARGUMENTS_FOR_STL_STACK */

// This is used to keep track of which field in which type of node is being
// parsed.  Field are nested (nodes are contained inside MFNode/SFNode fields)
// so a stack of these is needed:
typedef struct {
	const VrmlNodeType *nodeType;
        const char *fieldName;
} FieldRec;
#ifdef TWO_ARGUMENTS_FOR_STL_STACK  
stack< FieldRec*, list<FieldRec*> > currentField;
#else
stack< list<FieldRec*> > currentField;
#endif  /* TWO_ARGUMENTS_FOR_STL_STACK */

// This is used when the parser knows what kind of token it expects
// to get next-- used when parsing field values (whose types are declared
// and read by the parser) and at certain other places:
extern int expectToken;

// Current line number (set by lexer)
extern int currentLineNumber;

extern ParseTreeNode* parsetree;

// Some helper routines defined below:
static void beginProto(const char *);
static void beginClass(const char *);
static void endProto();
static void endClass();
int addField(const char *type, const char *name, ParseTreeNode*);
int addEventIn(const char *type, const char *name);
int addEventOut(const char *type, const char *name);
int addExposedField(const char *type, const char *name, ParseTreeNode* );
int add(void (VrmlNodeType::*)(const char *, int, const char*),
        const char *, const char *);
int add(void (VrmlNodeType::*)(const char *, int, const char*, ParseTreeNode*), 
        const char *, const char *, ParseTreeNode*);
int fieldType(const char *type);
void enterNode(const char *);
void exitNode();
void inScript();
void enterField(const char *);
void exitField();
void expect(int type);
void addSuperclass(const char *);

int hasFieldorEvent(const char *);

ParseTreeNode* tmppt;

/* STED type checking */

typedef struct { char* type;
         char* name;
       } DefNode;

list<DefNode*> deflist;

DefNode* finddef(const char*);
int subtype(const char*, const char*);
int check_subtype(const char*, const char*);
VrmlNodeType::NameTypeRec* getFieldorEvent(const char*);
VrmlNodeType::NameTypeRec* getFieldorEvent(VrmlNodeType*,const char*);

extern "C" void yyerror(const char *msg);


typedef union {
	char *string;

    /* Other types that will be needed by a true VRML implementation
     * (but are not defined by this parser due to the complexity):
     * Node *node;
     * list<Node *> *nodeList;
     */

     ParseTreeNode* pt;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		159
#define	YYFLAG		-32768
#define	YYNTBASE	44

#define YYTRANSLATE(x) ((unsigned)(x) <= 293 ? yytranslate[x] : 79)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    43,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    39,     2,    40,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    41,     2,    42,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    12,    14,    16,    20,
    23,    25,    27,    28,    38,    39,    40,    49,    50,    53,
    57,    63,    67,    73,    74,    80,    81,    87,    88,    91,
    95,    99,   103,   107,   112,   117,   119,   123,   124,   130,
   131,   134,   135,   139,   141,   143,   147,   151,   152,   158,
   164,   170,   172,   174,   176,   178,   180,   182,   184,   186,
   188,   190,   192,   194,   196,   198,   200,   202,   204,   207,
   210,   213,   216,   220,   222,   223,   226,   228,   230,   231,
   242,   243,   244,   254,   257,   259
};

static const short yyrhs[] = {    45,
     0,     0,    45,    46,     0,    47,     0,    48,     0,    60,
     0,    71,     0,    62,     0,    26,     3,    62,     0,    27,
     3,     0,    49,     0,    51,     0,     0,    28,     3,    50,
    39,    54,    40,    41,    45,    42,     0,     0,     0,    29,
     3,    52,    39,    58,    40,    53,    68,     0,     0,    54,
    55,     0,    34,     3,     3,     0,    34,     3,     3,    31,
    61,     0,    35,     3,     3,     0,    35,     3,     3,    31,
    61,     0,     0,    36,     3,     3,    56,    68,     0,     0,
    37,     3,     3,    57,    68,     0,     0,    58,    59,     0,
    34,     3,     3,     0,    35,     3,     3,     0,    36,     3,
     3,     0,    37,     3,     3,     0,    32,    61,    30,    61,
     0,    38,    61,    30,    61,     0,     3,     0,     3,    43,
     3,     0,     0,     3,    63,    41,    64,    42,     0,     0,
    64,    65,     0,     0,     3,    66,    68,     0,    60,     0,
    48,     0,    34,     3,     3,     0,    35,     3,     3,     0,
     0,    36,     3,     3,    67,    68,     0,    34,     3,     3,
    31,    61,     0,    35,     3,     3,    31,    61,     0,     4,
     0,     5,     0,    15,     0,     6,     0,    16,     0,     7,
     0,     8,     0,    17,     0,    10,     0,    18,     0,    11,
     0,    19,     0,    12,     0,    13,     0,    20,     0,    14,
     0,    21,     0,     9,    47,     0,     9,    33,     0,    22,
    69,     0,    31,    61,     0,    39,    70,    40,     0,    47,
     0,     0,    70,    47,     0,    72,     0,    74,     0,     0,
    23,     3,    73,    39,    54,    40,    77,    41,    45,    42,
     0,     0,     0,    24,     3,    75,    39,    58,    40,    77,
    76,    68,     0,    25,    78,     0,     3,     0,     3,    78,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   184,   187,   189,   193,   195,   196,   198,   202,   203,   210,
   223,   224,   227,   228,   234,   235,   236,   242,   243,   248,
   252,   259,   263,   270,   273,   279,   282,   290,   291,   296,
   300,   304,   308,   315,   319,   325,   335,   377,   378,   384,
   385,   389,   390,   400,   401,   404,   408,   412,   414,   419,
   427,   437,   438,   439,   440,   441,   442,   443,   444,   445,
   446,   447,   448,   449,   450,   451,   452,   453,   457,   459,
   462,   464,   471,   472,   475,   476,   482,   483,   486,   487,
   493,   494,   496,   501,   503,   507
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"SFBOOL","SFCOLOR","SFFLOAT","SFIMAGE","SFINT32","SFNODE","SFROTATION","SFSTRING",
"SFTIME","SFVEC2F","SFVEC3F","MFCOLOR","MFFLOAT","MFINT32","MFROTATION","MFSTRING",
"MFVEC2F","MFVEC3F","MFNODE","CLASS","EXTERNCLASS","EXTENDS","DEF","USE","PROTO",
"EXTERNPROTO","TO","IS","ROUTE","SFN_NULL","EVENTIN","EVENTOUT","FIELD","EXPOSEDFIELD",
"UNROUTE","'['","']'","'{'","'}'","'.'","vrmlscene","declarations","declaration",
"nodeDeclaration","protoDeclaration","proto","@1","externproto","@2","@3","interfaceDeclarations",
"interfaceDeclaration","@4","@5","externInterfaceDeclarations","externInterfaceDeclaration",
"routeDeclaration","routeEvent","node","@6","nodeGuts","nodeGut","@7","@8","fieldValue",
"mfnodeValue","nodes","classDeclaration","class","@9","externclass","@10","@11",
"extends","superclasses", NULL
};
#endif

static const short yyr1[] = {     0,
    44,    45,    45,    46,    46,    46,    46,    47,    47,    47,
    48,    48,    50,    49,    52,    53,    51,    54,    54,    55,
    55,    55,    55,    56,    55,    57,    55,    58,    58,    59,
    59,    59,    59,    60,    60,    61,    61,    63,    62,    64,
    64,    66,    65,    65,    65,    65,    65,    67,    65,    65,
    65,    68,    68,    68,    68,    68,    68,    68,    68,    68,
    68,    68,    68,    68,    68,    68,    68,    68,    68,    68,
    68,    68,    69,    69,    70,    70,    71,    71,    73,    72,
    75,    76,    74,    77,    78,    78
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     1,     1,     1,     3,     2,
     1,     1,     0,     9,     0,     0,     8,     0,     2,     3,
     5,     3,     5,     0,     5,     0,     5,     0,     2,     3,
     3,     3,     3,     4,     4,     1,     3,     0,     5,     0,
     2,     0,     3,     1,     1,     3,     3,     0,     5,     5,
     5,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
     2,     2,     3,     1,     0,     2,     1,     1,     0,    10,
     0,     0,     9,     2,     1,     2
};

static const short yydefact[] = {     2,
     1,    38,     0,     0,     0,     0,     0,     0,     0,     0,
     3,     4,     5,    11,    12,     6,     8,     7,    77,    78,
     0,    79,    81,     0,    10,    13,    15,    36,     0,     0,
    40,     0,     0,     9,     0,     0,     0,     0,     0,     0,
    18,    28,    18,    28,    37,    34,    35,    42,     0,     0,
     0,    39,    45,    44,    41,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    19,     0,
     0,     0,     0,     0,    29,     0,    16,    52,    53,    55,
    57,    58,     0,    60,    62,    64,    65,    67,    54,    56,
    59,    61,    63,    66,    68,     0,     0,    43,    46,    47,
    48,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    82,     2,     0,    70,    69,    75,    74,    71,    72,
     0,     0,     0,    20,    22,    24,    26,    85,    84,     2,
    30,    31,    32,    33,     0,     0,    17,     0,    50,    51,
    49,     0,     0,     0,     0,    86,     0,    83,    14,    73,
    76,    21,    23,    25,    27,    80,     0,     0,     0
};

static const short yydefgoto[] = {   157,
     1,    11,    12,    13,    14,    35,    15,    36,   114,    56,
    69,   144,   145,    57,    75,    16,    29,    17,    21,    40,
    55,    60,   123,    98,   119,   138,    18,    19,    32,    20,
    33,   135,   107,   129
};

static const short yypact[] = {-32768,
    66,-32768,     1,     6,     9,    10,    18,    20,    21,    21,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   -14,-32768,-32768,    29,-32768,-32768,-32768,     0,    22,    23,
-32768,     3,    16,-32768,    25,    26,    56,    21,    21,    12,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    64,    65,
    68,-32768,-32768,-32768,-32768,   -29,   -18,    46,   101,   109,
    74,    75,    81,    82,    96,    99,   102,    83,-32768,   103,
   104,   106,   107,    83,-32768,    93,-32768,-32768,-32768,-32768,
-32768,-32768,    70,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    -1,    21,-32768,   108,   111,
-32768,   140,   141,   142,   143,   144,   110,   145,   146,   147,
   149,-32768,-32768,   109,-32768,-32768,-32768,-32768,-32768,-32768,
    21,    21,   109,   122,   123,-32768,-32768,   144,-32768,-32768,
-32768,-32768,-32768,-32768,   109,     7,-32768,    48,-32768,-32768,
-32768,    21,    21,   109,   109,-32768,    34,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   155,   156,-32768
};

static const short yypgoto[] = {-32768,
  -110,-32768,   -82,   117,-32768,-32768,-32768,-32768,-32768,   115,
-32768,-32768,-32768,   116,-32768,   119,   -10,   137,-32768,-32768,
-32768,-32768,-32768,   -44,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    88,    35
};


#define	YYLAST		163


static const short yytable[] = {    30,
   116,     2,   136,    22,    64,    65,    66,    67,    23,     2,
    68,    24,    25,   118,    48,    70,    71,    72,    73,   147,
    26,    74,    27,    28,     5,     6,    31,    46,    47,     3,
     4,     2,     5,     6,     7,     8,     2,   117,     9,     7,
     8,    41,    37,     9,    10,    49,    50,    51,   149,    10,
     2,    38,    39,    52,    42,   151,     3,     4,    45,     5,
     6,     7,     8,    43,    44,     9,    61,    62,     2,   137,
    63,    10,     2,     5,     6,   156,    99,   100,   141,    64,
    65,    66,    67,   101,   102,    76,   120,   150,     3,     4,
   148,     5,     6,     7,     8,     5,     6,     9,   103,   154,
   155,   104,   115,    10,   105,   108,   109,   106,   110,   111,
   139,   140,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,   152,   153,   113,    70,    71,    72,    73,   121,    97,
    77,   122,   124,   125,   126,   127,   128,   131,   132,   133,
   130,   134,   142,   143,   158,   159,    53,    58,    54,    59,
    34,   112,   146
};

static const short yycheck[] = {    10,
    83,     3,   113,     3,    34,    35,    36,    37,     3,     3,
    40,     3,     3,    96,     3,    34,    35,    36,    37,   130,
     3,    40,     3,     3,    26,    27,    41,    38,    39,    23,
    24,     3,    26,    27,    28,    29,     3,    39,    32,    28,
    29,    39,    43,    32,    38,    34,    35,    36,    42,    38,
     3,    30,    30,    42,    39,   138,    23,    24,     3,    26,
    27,    28,    29,    39,    39,    32,     3,     3,     3,   114,
     3,    38,     3,    26,    27,    42,     3,     3,   123,    34,
    35,    36,    37,     3,     3,    40,    97,    40,    23,    24,
   135,    26,    27,    28,    29,    26,    27,    32,     3,   144,
   145,     3,    33,    38,     3,     3,     3,    25,     3,     3,
   121,   122,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,   142,   143,    41,    34,    35,    36,    37,    31,    31,
    40,    31,     3,     3,     3,     3,     3,     3,     3,     3,
    41,     3,    31,    31,     0,     0,    40,    43,    40,    44,
    24,    74,   128
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */


/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{ parsetree=yyvsp[0].pt; ;
    break;}
case 2:
{ yyval.pt=pt_node(PT_DECS,NULL); ;
    break;}
case 3:
{ yyvsp[-1].pt->addChild(yyvsp[0].pt); 
                                            yyval.pt=yyvsp[-1].pt; ;
    break;}
case 4:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 5:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 6:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 7:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 9:
{ DefNode* dp=new DefNode;
                                                  yyval.pt=pt_node(PT_DEF,yyvsp[-1].string,yyvsp[0].pt);
                                                  myfree(yyvsp[-1].string);
                                                  yyval.pt->classname=yyvsp[0].pt->classname;
                                                  dp->type=yyvsp[0].pt->classname;
                                                  dp->name=strdup(yyvsp[-1].string);
                                                  deflist.push_front(dp); ;
    break;}
case 10:
{ DefNode* dp=finddef(yyvsp[0].string);
                   yyval.pt=pt_node(PT_USE,yyvsp[0].string);
                   if (dp)
                     yyval.pt->classname=dp->type;
                   else
                    { yyerror("No previous DEF "); 
                      cerr << yyvsp[0].string <<"\n";
                      yyval.pt->classname="UNKNOWN";
                    }
                   myfree(yyvsp[0].string); ;
    break;}
case 11:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 12:
{yyval.pt=yyvsp[0].pt;;
    break;}
case 13:
{ beginProto(yyvsp[0].string); ;
    break;}
case 14:
{ endProto();   
                                            yyval.pt=pt_node(PT_PROTO,yyvsp[-7].string,yyvsp[-4].pt,yyvsp[-1].pt);
                                            myfree(yyvsp[-7].string);;
    break;}
case 15:
{ beginProto(yyvsp[0].string); ;
    break;}
case 16:
{ expect(MFSTRING); ;
    break;}
case 17:
{ endProto();
                                                       yyval.pt=pt_node(PT_EXTPROTO,yyvsp[-6].string,yyvsp[-3].pt,yyvsp[0].pt);
                                                       myfree(yyvsp[-6].string); ;
    break;}
case 18:
{ yyval.pt=pt_node(PT_INTERFACE,NULL); ;
    break;}
case 19:
{ yyvsp[-1].pt->addChild(yyvsp[0].pt); 
                           yyval.pt=yyvsp[-1].pt; ;
    break;}
case 20:
{ addEventIn(yyvsp[-1].string, yyvsp[0].string);
                                                       tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                       yyval.pt=pt_node(PT_EVENTIN,yyvsp[0].string,tmppt);
                                                        myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 21:
{ addEventIn(yyvsp[-3].string, yyvsp[-2].string);
                                                    tmppt=pt_node(PT_ID,yyvsp[-3].string);
                                                    yyval.pt=pt_node(PT_EVENTIN_IS,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                                                    check_subtype(yyvsp[0].pt->classname,
                                                                  yyvsp[-3].string);
                                                    myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 22:
{ addEventOut(yyvsp[-1].string, yyvsp[0].string);
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                  yyval.pt=pt_node(PT_EVENTOUT,yyvsp[0].string,tmppt);
 						  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 23:
{ addEventOut(yyvsp[-3].string, yyvsp[-2].string);
                                                    tmppt=pt_node(PT_ID,yyvsp[-3].string);
                                                    yyval.pt=pt_node(PT_EVENTOUT_IS,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                                                    check_subtype(yyvsp[0].pt->classname,
                                                                  yyvsp[-3].string);
 						    myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 24:
{ int type = fieldType(yyvsp[-1].string);
                                                  expect(type); ;
    break;}
case 25:
{ tmppt=pt_node(PT_ID,yyvsp[-3].string);
                                                  check_subtype(yyvsp[0].pt->classname,
                                                                yyvsp[-3].string);
                                                  yyval.pt=pt_node(PT_FIELD,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                                                  addField(yyvsp[-3].string, yyvsp[-2].string, yyvsp[0].pt);
                                                  myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 26:
{ int type = fieldType(yyvsp[-1].string);
    						  expect(type); ;
    break;}
case 27:
{ tmppt=pt_node(PT_ID,yyvsp[-3].string);
                                                  check_subtype(yyvsp[0].pt->classname,
                                                                yyvsp[-3].string);
                                                  yyval.pt=pt_node(PT_EXPFIELD,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                                                  addExposedField(yyvsp[-3].string, yyvsp[-2].string, yyvsp[0].pt);
                                                  myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 28:
{ yyval.pt=pt_node(PT_EXTINTERFACE,NULL); ;
    break;}
case 29:
{ yyvsp[-1].pt->addChild(yyvsp[0].pt); 
                         yyval.pt=yyvsp[-1].pt; ;
    break;}
case 30:
{ addEventIn(yyvsp[-1].string, yyvsp[0].string);
                                                              tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                              yyval.pt=pt_node(PT_EVENTIN,yyvsp[0].string,tmppt);
        						      myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 31:
{ addEventOut(yyvsp[-1].string, yyvsp[0].string);
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                  yyval.pt=pt_node(PT_EVENTOUT,yyvsp[0].string,tmppt);
        			       		  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 32:
{ addField(yyvsp[-1].string, yyvsp[0].string, NULL);
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                  yyval.pt=pt_node(PT_FIELD,yyvsp[0].string,tmppt);
						  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 33:
{ addExposedField(yyvsp[-1].string, yyvsp[0].string, NULL);
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                                  yyval.pt=pt_node(PT_EXPFIELD,yyvsp[0].string,tmppt);
						  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 34:
{ yyval.pt=pt_node(PT_ROUTE,NULL,yyvsp[-2].pt,yyvsp[0].pt);
           check_subtype(yyvsp[-2].pt->classname,yyvsp[0].pt->classname);
         ;
    break;}
case 35:
{ yyval.pt=pt_node(PT_UNROUTE,NULL,yyvsp[-2].pt,yyvsp[0].pt);
           check_subtype(yyvsp[-2].pt->classname,yyvsp[0].pt->classname);
         ;
    break;}
case 36:
{ VrmlNodeType::NameTypeRec* nt=getFieldorEvent(yyvsp[0].string);
                           yyval.pt=pt_node(PT_R_EVENT_A,yyvsp[0].string);
                           if (nt)
                             yyval.pt->classname=nt->typestring;
                           else
                            { yyval.pt->classname="UNKNOWN";
                              yyerror(yyvsp[0].string);  
                              cerr << " is not a local field or event !\n";
                            }
                           myfree(yyvsp[0].string); ;
    break;}
case 37:
{ int ftype;
            char* node_classname;
            VrmlNodeType *t;
            tmppt=pt_node(PT_R_EVENT_A,yyvsp[0].string);
            if (ftype=hasFieldorEvent(yyvsp[-2].string))
              { VrmlNodeType::NameTypeRec* nt=getFieldorEvent(yyvsp[-2].string);                                           yyval.pt=pt_node(ftype,yyvsp[-2].string,tmppt);
                node_classname=nt->typestring;
	      }
            else
              { DefNode* dp=finddef(yyvsp[-2].string);
                yyval.pt=pt_node(PT_R_EVENT_C,yyvsp[-2].string,tmppt);
                if (dp)
                   node_classname=dp->type;
                 else
                   node_classname="UNKNOWN";
              }
          t = VrmlNodeType::find(node_classname);
          if (t)
            { VrmlNodeType::NameTypeRec* nt=getFieldorEvent(t,yyvsp[0].string);
              if (nt)
                 yyval.pt->classname=nt->typestring;
                else
                 { yyval.pt->classname="UNKNOWN";
                   yyerror(yyvsp[-2].string);
                   cerr << " has no field or event " 
                        << yyvsp[0].string << " !\n";
                 }
            }
           else yyval.pt->classname="UNKNOWN";
          myfree(yyvsp[-2].string); myfree(yyvsp[0].string); ;
    break;}
case 38:
{ enterNode(yyvsp[0].string); ;
    break;}
case 39:
{ exitNode();
                                                  yyval.pt=pt_node(PT_NODE,yyvsp[-4].string,yyvsp[-1].pt);
                                                  yyval.pt->classname=strdup(yyvsp[-4].string);
                                                  myfree(yyvsp[-4].string);;
    break;}
case 40:
{ yyval.pt=pt_node(PT_GUTS,NULL); ;
    break;}
case 41:
{ yyvsp[-1].pt->addChild(yyvsp[0].pt); 
                              yyval.pt=yyvsp[-1].pt; ;
    break;}
case 42:
{ enterField(yyvsp[0].string); ;
    break;}
case 43:
{ VrmlNodeType::NameTypeRec* nt;
                                  nt=getFieldorEvent(yyvsp[-2].string);
                                  if (nt)
                                     { check_subtype(yyvsp[0].pt->classname,
                                                     nt->typestring);
                                     }
                                  exitField(); 
                                 
                                  yyval.pt=pt_node(PT_IDENTIFIER,yyvsp[-2].string,yyvsp[0].pt);
                                  myfree(yyvsp[-2].string); ;
    break;}
case 46:
{ inScript();
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string); 
                                                  yyval.pt=pt_node(PT_EVENTIN,yyvsp[0].string,tmppt);
                                                  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 47:
{ inScript();
                                                  tmppt=pt_node(PT_ID,yyvsp[-1].string); 
                                                  yyval.pt=pt_node(PT_EVENTOUT,yyvsp[0].string,tmppt);
                                                  myfree(yyvsp[-1].string); myfree(yyvsp[0].string); ;
    break;}
case 48:
{ inScript(); int type = fieldType(yyvsp[-1].string);
    							      expect(type); ;
    break;}
case 49:
{ tmppt=pt_node(PT_ID,yyvsp[-3].string);
                                                  check_subtype(yyvsp[0].pt->classname,
                                                                yyvsp[-3].string); 
                                                  yyval.pt=pt_node(PT_FIELD,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                                                  myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 50:
{ inScript(); 
                          tmppt=pt_node(PT_ID,yyvsp[-3].string); 
                          check_subtype(yyvsp[0].pt->classname,
                                        yyvsp[-3].string);
                          yyval.pt=pt_node(PT_EVENTIN_IS,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                          myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 51:
{ inScript();
                          tmppt=pt_node(PT_ID,yyvsp[-3].string);
                          check_subtype(yyvsp[0].pt->classname,
                                        yyvsp[-3].string); 
                          yyval.pt=pt_node(PT_EVENTOUT_IS,yyvsp[-2].string,tmppt,yyvsp[0].pt);
                          myfree(yyvsp[-3].string); myfree(yyvsp[-2].string); ;
    break;}
case 52:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFBool"; ;
    break;}
case 53:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFColor"; ;
    break;}
case 54:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFColor"; ;
    break;}
case 55:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFFloat"; ;
    break;}
case 56:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFFloat"; ;
    break;}
case 57:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFImage"; ;
    break;}
case 58:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFInt32"; ;
    break;}
case 59:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFInt32"; ;
    break;}
case 60:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFRotation"; ;
    break;}
case 61:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFRotation"; ;
    break;}
case 62:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFString"; ;
    break;}
case 63:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFString"; ;
    break;}
case 64:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFTime"; ;
    break;}
case 65:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFVec2f"; ;
    break;}
case 66:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFVec2f"; ;
    break;}
case 67:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="SFVec3f"; ;
    break;}
case 68:
{ yyval.pt=yyvsp[0].pt; yyval.pt->classname="MFVec3f"; ;
    break;}
case 69:
{ yyval.pt=pt_node(PT_SFNODE,NULL,yyvsp[0].pt);
                                 yyval.pt->classname=yyvsp[0].pt->classname; ;
    break;}
case 70:
{ yyval.pt=pt_node(PT_SFN_NULL,NULL);
                                 yyval.pt->classname="NULL";
                               ;
    break;}
case 71:
{ yyval.pt=pt_node(PT_MFNODE,NULL,yyvsp[0].pt); 
                                 yyval.pt->classname="MFNode"; ;
    break;}
case 72:
{ yyval.pt=pt_node(PT_IS,NULL,yyvsp[0].pt); 
                                 yyval.pt->classname=yyvsp[0].pt->classname; ;
    break;}
case 73:
{ yyval.pt=pt_node(PT_MFNODE2,NULL,yyvsp[-1].pt); ;
    break;}
case 74:
{ yyval.pt=yyvsp[0].pt; ;
    break;}
case 75:
{ yyval.pt=pt_node(PT_DECS,NULL); ;
    break;}
case 76:
{ yyvsp[-1].pt->addChild(yyvsp[0].pt); 
                                 yyval.pt=yyvsp[-1].pt; ;
    break;}
case 77:
{ yyval.pt=yyvsp[0].pt; ;
    break;}
case 78:
{ yyval.pt=yyvsp[0].pt; ;
    break;}
case 79:
{ beginClass(yyvsp[0].string); ;
    break;}
case 80:
{ endClass();
                                                   yyval.pt=pt_node(PT_CLASS,yyvsp[-8].string,yyvsp[-5].pt,yyvsp[-3].pt,yyvsp[-1].pt);
                                                   myfree(yyvsp[-8].string); ;
    break;}
case 81:
{ beginClass(yyvsp[0].string); ;
    break;}
case 82:
{ expect(MFSTRING); ;
    break;}
case 83:
{ endClass();
                                                      yyval.pt=pt_node(PT_EXTCLASS,yyvsp[-7].string,yyvsp[-4].pt,yyvsp[-2].pt,yyvsp[0].pt);
                                                      myfree(yyvsp[-7].string); ;
    break;}
case 84:
{ yyval.pt=yyvsp[0].pt; ;
    break;}
case 85:
{ addSuperclass(yyvsp[0].string);
                                             tmppt=pt_node(PT_ID,yyvsp[0].string);
                                             yyval.pt=pt_node(PT_SUPERS,NULL,tmppt);
                                             myfree(yyvsp[0].string); ;
    break;}
case 86:
{ addSuperclass(yyvsp[-1].string);
                                             tmppt=pt_node(PT_ID,yyvsp[-1].string);
                                             yyvsp[0].pt->addChild_front(tmppt);
                                             yyval.pt=yyvsp[0].pt;
                                             myfree(yyvsp[-1].string); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}


extern char* yytext;

extern int column;

void err_indent(int d) { while(d--) { cerr << " "; }}

extern char* linebuffer;

void 
yyerror(const char *msg)
{     cerr << "\n" << linebuffer << "\n";
      err_indent(column);
      cerr << "^\n";
      cerr << "Error near line " << currentLineNumber << ": " << msg;
      expect(0);
}

int hasFieldorEvent(const char* name)
{ VrmlNodeType *t;
  int ft;
  if (currentProtoStack.empty()) return 0;
  t = currentProtoStack.top();
  
  if (ft=t->hasField(name))
    { if (ft==SFNODE) return PT_ROUTE_EVENT_F_SF;
      if (ft==MFNODE) return PT_ROUTE_EVENT_F_MF;
    }
  if (ft=t->hasExposedField(name))
    { if (ft==SFNODE) return PT_ROUTE_EVENT_EX_SF;
      if (ft==MFNODE) return PT_ROUTE_EVENT_EX_MF;
    }
  if (ft=t->hasEventIn(name))
    { if (ft==SFNODE) return PT_ROUTE_EVENT_EI_SF;
      if (ft==MFNODE) return PT_ROUTE_EVENT_EI_MF;
    }
  if (ft=t->hasEventOut(name))
   { if (ft==SFNODE) return PT_ROUTE_EVENT_EO_SF;
     if (ft==SFNODE) return PT_ROUTE_EVENT_EO_MF;
   }
  return 0;
}

VrmlNodeType::NameTypeRec* getFieldorEvent(const char* name)
{ VrmlNodeType *t;
  FieldRec* fr;
  if (!currentField.empty())
    { VrmlNodeType::NameTypeRec* res;
      fr=currentField.top();
      res=getFieldorEvent((VrmlNodeType*)fr->nodeType,name);
      if (res) return res;
    }
  if (currentProtoStack.empty()) return NULL;
     t = currentProtoStack.top();
  return getFieldorEvent(t,name);
}

VrmlNodeType::NameTypeRec* getFieldorEvent(VrmlNodeType *t, const char* name)
{ VrmlNodeType::NameTypeRec *res;
  list<VrmlNodeType*>::iterator i;
  if (res=t->get(t->getEventIns(),name)) return res;
  if (res=t->get(t->getEventOuts(),name)) return res;
  if (res=t->get(t->getFields(),name)) return res;
  if (t->isClass())
    { list<VrmlNodeType*> supers=t->getSuperClasses();
      for(i=supers.begin();i!=supers.end();i++)
         if (res=getFieldorEvent((*i),name)) return res;
    }
  return(NULL);
}

static void
beginProto(const char *protoName)
{
	// Any protos in the implementation are in a local namespace:
    VrmlNodeType::pushNameSpace();
    deflist.push_front((DefNode*) NULL);

    VrmlNodeType *t = new VrmlNodeType(protoName);
    currentProtoStack.push(t);
}

static void
beginClass(const char *protoName)
{
    // Any protos in the implementation are in a local namespace:
    VrmlNodeType::pushNameSpace();
    deflist.push_front((DefNode*) NULL);

    VrmlNodeType *t = new VrmlNodeType(protoName,1);
    currentProtoStack.push(t);
}

static void
endProto()
{
    // Make any protos defined in implementation unavailable:
    VrmlNodeType::popNameSpace();

    // Remove everything up to and including the next NULL marker:
    list<DefNode*>::iterator i;
    for (i = deflist.begin(); i != deflist.end();) {
    	DefNode *nodeType = *i;
        ++i;
        deflist.pop_front();

        if (nodeType ==  NULL) {
            break;
        }
        else { delete nodeType;
        }
      }

    // Add this proto definition:
	if (currentProtoStack.empty()) {
    	cerr << "Error: Empty PROTO stack!\n";
    }
    else {
    	VrmlNodeType *t = currentProtoStack.top();
    	currentProtoStack.pop();
        VrmlNodeType::addToNameSpace(t);
    }
}

static void
endClass()
{ endProto();
}

int
addField(const char *type, const char *name, ParseTreeNode* pt)
{
	return add(&VrmlNodeType::addField, type, name, pt);
}

int
addEventIn(const char *type, const char *name)
{
	return add(&VrmlNodeType::addEventIn, type, name);
}
int
addEventOut(const char *type, const char *name)
{
	return add(&VrmlNodeType::addEventOut, type, name);
}
int
addExposedField(const char *type, const char *name, ParseTreeNode* pt)
{
	return add(&VrmlNodeType::addExposedField, type, name, pt);
}

void addSuperclass(const char* super)
 {  VrmlNodeType *t = currentProtoStack.top();
    t->addSuperclass(super);
 }

int
add(void (VrmlNodeType::*func)(const char *, int, const char*, ParseTreeNode*), 
	const char *typeString, const char *name,
        ParseTreeNode* pt)
{
    int type = fieldType(typeString);

    if (type == 0) {
    	cerr << "Error: invalid field type: " << type << "\n";
    }

    // Need to add support for Script nodes:
	// if (inScript) ... ???

	if (currentProtoStack.empty()) {
    	cerr << "Error: declaration outside of prototype\n";
        return 0;
    }
   VrmlNodeType *t = currentProtoStack.top();
    (t->*func)(name, type, typeString, pt);
    
    return type;
}

int
add(void (VrmlNodeType::*func)(const char *, int, const char*), 
	const char *typeString, const char *name)
{
    int type = fieldType(typeString);

    if (type == 0) {
    	cerr << "Error: invalid field type: " << type << "\n";
    }

    // Need to add support for Script nodes:
	// if (inScript) ... ???

	if (currentProtoStack.empty()) {
    	cerr << "Error: declaration outside of prototype\n";
        return 0;
    }
    VrmlNodeType *t = currentProtoStack.top();
    (t->*func)(name, type, typeString);
    
    return type;
}


int
fieldType(const char *type)
{
    if (strcmp(type, "SFBool") == 0) return SFBOOL;
    if (strcmp(type, "SFColor") == 0) return SFCOLOR;
    if (strcmp(type, "SFFloat") == 0) return SFFLOAT;
    if (strcmp(type, "SFImage") == 0) return SFIMAGE;
    if (strcmp(type, "SFInt32") == 0) return SFINT32;
    if (strcmp(type, "SFNode") == 0) return SFNODE;
    if (strcmp(type, "SFRotation") == 0) return SFROTATION;
    if (strcmp(type, "SFString") == 0) return SFSTRING;
    if (strcmp(type, "SFTime") == 0) return SFTIME;
    if (strcmp(type, "SFVec2f") == 0) return SFVEC2F;
    if (strcmp(type, "SFVec3f") == 0) return SFVEC3F;
    if (strcmp(type, "MFColor") == 0) return MFCOLOR;
    if (strcmp(type, "MFFloat") == 0) return MFFLOAT;
    if (strcmp(type, "MFInt32") == 0) return MFINT32;
    if (strcmp(type, "MFNode") == 0) return MFNODE;
    if (strcmp(type, "MFRotation") == 0) return MFROTATION;
    if (strcmp(type, "MFString") == 0) return MFSTRING;
    if (strcmp(type, "MFVec2f") == 0) return MFVEC2F;
    if (strcmp(type, "MFVec3f") == 0) return MFVEC3F;
    
    VrmlNodeType *t = VrmlNodeType::find(type);
    if /* ((t!=NULL) && (t->isClass())) */
       /* we allow also PROTOs as Type Restrictions*/
      (t!=NULL)
      { return SFNODE;
      }

    cerr << "Illegal field type: " << type << "\n";

    return 0;
}

void
enterNode(const char *nodeType)
{
    VrmlNodeType *t = VrmlNodeType::find(nodeType);
    if (t == NULL) {
    	char tmp[1000];
        VrmlNodeType::print_types();
        sprintf(tmp, "Unknown node type '%s'", nodeType);
    	yyerror(tmp);
    }
    FieldRec *fr = new FieldRec;
    fr->nodeType = t;
    fr->fieldName = NULL;
    currentField.push(fr);
}

void
exitNode()
{
	FieldRec *fr = currentField.top();
    assert(fr != NULL);
	currentField.pop();

    delete fr;
}

void
inScript()
{
	FieldRec *fr = currentField.top();
    if (fr->nodeType == NULL ||
    	strcmp(fr->nodeType->getName(), "Script") != 0) {
        yyerror("interface declaration outside of Script or prototype");
    }
}

void
enterField(const char *fieldName)
{
    FieldRec *fr = currentField.top();
    assert(fr != NULL);

    fr->fieldName = fieldName;
    if (fr->nodeType != NULL) {
    	// enterField is called when parsing eventIn and eventOut IS
        // declarations, in which case we don't need to do anything special--
        // the IS IDENTIFIER will be returned from the lexer normally.
    	if (fr->nodeType->hasEventIn(fieldName) ||
            fr->nodeType->hasEventOut(fieldName))
           return;
    
        int type = fr->nodeType->hasField(fieldName);
        if (type != 0) {
        	// Let the lexer know what field type to expect:
        	expect(type);
        }
        else {
        	cerr << "Error: Node's of type " << fr->nodeType->getName() <<
            	" do not have fields/eventIn/eventOut named " <<
                fieldName << "\n";
            // expect(ANY_FIELD);
        }
    }
    // else expect(ANY_FIELD);
}

void
exitField()
{
	FieldRec *fr = currentField.top();
    assert(fr != NULL);

	fr->fieldName = NULL;
}

void
expect(int type)
{
	expectToken = type;
}

DefNode* finddef(const char* name)
{  // Look through the deflistL
  list<DefNode*>::iterator i;
  for (i = deflist.begin(); i != deflist.end(); i++) {
    	DefNode *nt = *i;
    	if ((nt !=  NULL) && 
            (strcmp(nt->name,name)) == 0) {
            return nt;
        }
    }
    return  NULL;
}

int subtype(const char* t1, const char* t2)
{ VrmlNodeType *tn1, *tn2; 
  
  if (strcmp(t1,t2)==0) return(1);
  if (strcmp(t1,"NULL")==0) return(1);
  if ((strcmp(t2,"SFNode")==0) || (strcmp(t2,"MFNode")==0))
     return(1);
  if ((strcmp(t1,"SFNode")==0) || (strcmp(t1,"MFNode")==0))
     return(0);
  tn1= VrmlNodeType::find(t1); 
  tn2= VrmlNodeType::find(t2);
  if ((!tn1) || (!tn2)) return(0);
  
  if (tn1->isClass())
    { list<VrmlNodeType*> supers=tn1->getSuperClasses();
      list<VrmlNodeType*>::const_iterator j;
      for (j = supers.begin(); j != supers.end(); j++) 
        if (subtype((*j)->getName(),t2)) return(1);
    }
  return(0);
}

int check_subtype(const char* t1, const char* t2)
{ int ant=2;
#ifdef TCHECKDEBUG 
 cerr << currentLineNumber << " subtype: " << t1 << " " << t2 << " \n";
#endif
  if ((strcmp(t1,"UNKNOWN")==0) 
     || (strcmp(t2,"UNKNOWN")==0)) ant=1;
  else
  if ((t2[0]=='M') && (t2[1]=='F'))
    { if (strcmp(t1+2,t2+2)==0) ant=1;
    }
  else
  if ((t1[0]=='S') && (t1[1]=='F')
      && (t2[0]=='S') && (t2[1]=='F'))
	{ if (strcmp(t1+2,t2+2)==0) ant=1;
          else ant=0;
        }
  else ant=subtype(t1,t2);
  if (!ant)
     { yyerror(t1); 
       cerr << " is not a subtype of " 
            << t2 << " !\n";
     }
  return(ant);
}










